//
//  HTTPLoadProgressExampleViewController.m
//  HTTPLoadProgressExample
//
//  Created by Brian Dittmer on 3/13/11.
//  Copyright 2011 __MyCompanyName__. All rights reserved.
//

#import "HTTPLoadProgressExampleViewController.h"

#define URL_TO_DOWNLOAD @"http://upload.wikimedia.org/wikipedia/commons/8/88/San_Francisco_Pano.jpg"

@implementation HTTPLoadProgressExampleViewController

- (void)dealloc {
    [responseData release];
    [super dealloc];
}

- (void)didReceiveMemoryWarning {
    // Releases the view if it doesn't have a superview.
    [super didReceiveMemoryWarning];
    
    // Release any cached data, images, etc that aren't in use.
}

#pragma mark - View lifecycle

- (void)viewDidLoad {
    [super viewDidLoad];
    
    NSMutableURLRequest * request = [[[NSMutableURLRequest alloc] initWithURL:[NSURL URLWithString:URL_TO_DOWNLOAD]] autorelease];
    [request setHTTPMethod:@"GET"];
    
    NSURLConnection * conn = [NSURLConnection connectionWithRequest:request delegate:self];
    if(conn) 
		responseData = [[NSMutableData data] retain];
    else
        NSLog(@":(");
}

- (void)connection:(NSURLConnection *)connection didReceiveResponse:(NSURLResponse *)response {
	[responseData setLength:0];
    responseDataSize = (NSUInteger)[response expectedContentLength];
}

- (void)connection:(NSURLConnection *)connection didReceiveData:(NSData *)data {
	[responseData appendData:data];
    
    float progress = (float)[responseData length] / (float)responseDataSize;
    progressView.progress = progress;
}

- (void)connection:(NSURLConnection *)connection didFailWithError:(NSError *)error {
	NSLog(@":(");
}

- (void)connectionDidFinishLoading:(NSURLConnection *)connection {
    UIAlertView * complete = [[[UIAlertView alloc] initWithTitle:@"Done" 
                                                         message:@"Download complete." 
                                                        delegate:nil 
                                               cancelButtonTitle:@"Cool" otherButtonTitles:nil] autorelease];
    [complete show];
}

- (void)viewDidUnload {
    [super viewDidUnload];
    // Release any retained subviews of the main view.
    // e.g. self.myOutlet = nil;
}

- (BOOL)shouldAutorotateToInterfaceOrientation:(UIInterfaceOrientation)interfaceOrientation {
    // Return YES for supported orientations
    return (interfaceOrientation == UIInterfaceOrientationPortrait);
}

@end
